// Program: Lesson 30 - Excercise 2

#include <iostream.h>

template <class T>
class list
{
 public:
	list(void);
	list(const T& t, list<T>*& prev);
	~list(void);

	void 	add(const T& t);
	void 	remove(const T& t);
	void 	print(void);
	void 	clear(void);

 private:
	T	item;
	list<T>* next;
	list<T>** last;
 };

template <class T>
list<T>::list(void) { next = NULL; last = NULL; }

template <class T>
list<T>::list(const T& t, list<T>*& prev)
 {
	item=t;
	next=prev;
	last=&prev;
	prev->last=&next;
	prev=this;
 }

template <class T>
list<T>::~list(void)
 {
	if (next != NULL)
	  next -> last = last;
	if (last != NULL)
	  *last = next;
 }

template <class T>
void list<T>::add(const T& t)
 {
	new list<T>(t,next);
 }

template <class T>
void list<T>::remove(const T& t)
 {
	if (next != NULL) {
		if (next -> item == t)
		  delete next;
		else
		  next -> remove(t);
		}
 }

template <class T>
void list<T>::print(void)
{
	if(next != NULL) {
		cout << next -> item << " ";
		next -> print();
		}
}

template <class T>
void list<T>::clear(void)
 {
	while (next != NULL)
	 delete next;
 }

void main(void)
 {
	list<float> l;
	l.add(3.14);
	l.add(6.7);
	l.add(10.1);
	l.remove(6.7);
	l.print();
	l.clear();
 }
