// Program: Lesson 30 - Excercise 3
#include <iostream.h>

template <class T>
class list
{
 public:
	list(void);
	list(const T& t, list<T>*& prev);
	~list(void);

	void     add(const T& t);
	void     remove(const T& t);
	void 	 clear(void);
	list<T>* retrieve(const T& t);
	T&	 element(void);

 private:
	T	item;
	list<T>* next;
	list<T>** last;
 };

template <class T>
list<T>::list(void) { next=NULL; last=NULL; }

template <class T>
list<T>::list(const T& t, list<T>*& prev) : item(t)
 {
	next=prev;
	last=&prev;
	prev->last=&next;
	prev=this;
 }

template <class T>
list<T>::~list(void)
 {
	if (next != NULL)
	  next -> last = last;
	if (last != NULL)
	  *last = next;
 }

template <class T>
void list<T>::add(const T& t)
 {
	new list<T>(t,next);
 }

template <class T>
void list<T>::remove(const T& t)
 {
	if (next != NULL) {
		if (next -> item == t)
		  delete next;
		else
		  next -> remove(t);
		}
 }


template <class T>
list<T>* list<T>::retrieve(const T& t)
 {
	list<T>* iter;
	for (iter = next; iter != NULL; iter = iter -> next)
	   if (iter -> item == t)
	     return iter;
	return NULL;
 }



template <class T>
void list<T>::clear(void)
 {
	while (next != NULL)
	 delete next;
 }


template <class T>
T& list<T>::element(void) { return item; }

template <class X, class Y>
class pair
{
 public:
	pair(X new_x, Y new_y) : x(new_x), y(new_y) {}
	pair(const pair<X,Y>& p) : x(p.x), y(p.y) {}
	pair(void) {}
	int operator==(const pair<X,Y>& p) { return x == p.x; }
	X& element1(void) 		   { return x; }
	Y& element2(void) 		   { return y; }
 private:
	X x;
	Y y;
 };

template <class Key, class Item>
class set
{
 public:
	set(void);
	~set();
	void  add(Key key, Item item);
	Item& retrieve(Key key);

 private:
	list< pair<Key,Item> > set_list;
};

template <class Key,class Item>
set<Key,Item>::set(void)  {}

template <class Key,class Item>
set<Key,Item>::~set()
 {
	set_list.clear();
 }

template <class Key,class Item>
void set<Key,Item>::add(Key key, Item item)
 {
	set_list.add( pair<Key,Item>(key,item) );
 }

template <class Key,class Item>
Item& set<Key,Item>::retrieve(Key key)
{
	list< pair<Key,Item> > * set_elem;
	pair<Key,Item> simple_pair;
	simple_pair.element1()=key;
	set_elem=set_list.retrieve( simple_pair  );

	//handle case when retrieving key that does not exist:
	//in this case, add an empty pair<key,item>, and retrieve it.
	if (set_elem==NULL) {
		set_list.add( simple_pair );
		set_elem=set_list.retrieve( simple_pair  );
		}
	return set_elem->element().element2();
}



void main(void)
 {
	set<int,float> s;
	s.add(45, 3.14);
	s.add(87, 84.8);
	cout << "found: " << s.retrieve(87) << endl;
 }
