#include <iostream.h>
#include <stdlib.h>

class array {
 public:
   array(int size);
   long sum(void);
   int average_value(void);
   void show_array(void);
   int add_value(int);
 private:
   int *data;
   int size;
   int index;
 };

 array::array(int size)
  {
    data = new int[size];

    if (data == NULL)
     {
       cerr << "Insufficient memory--program ending" << endl;
       exit(1);
     }

    array::size = size;
    array::index = 0;
  }

long array::sum(void)
 {
    long sum = 0;
    int i;

    for (i = 0; i < index; i++)
      sum += data[i];  
 
    return(sum);
 }

int array::average_value(void)
 {
    long sum = 0;
    int i;

    for (i = 0; i < index; i++)
      sum += data[i];

    return(sum / index);
 }


void array::show_array(void)
 {
   int i;

   for (i = 0; i < index; i++)
     cout << data[i] << ' ';

   cout << endl;
 }

int array::add_value(int value) 
 {
   if (index == size)
     return(-1);       // Array is full
   else
     {
       data[index] = value;
       index++;  
       return(0);     // Successful
     }
 }

void main(void)
 {
   array numbers(100);   // 100 element array
   int i;

   for (i = 0; i < 50; i++)
     numbers.add_value(i);

   numbers.show_array();

   cout << "The sum of the numbers is " << numbers.sum() << endl;
   cout << "The average value is " << numbers.average_value() << endl;
 }

   
